package com.cringe_studios.svd.ui.home;

import android.os.Build;
import android.os.Bundle;
import android.text.Html;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProvider;
import androidx.navigation.Navigation;
import androidx.navigation.fragment.NavHostFragment;
import androidx.navigation.ui.NavigationUI;

import com.cringe_studios.svd.R;
import com.cringe_studios.svd.databinding.FragmentHomeBinding;

import org.mcsoxford.rss.RSSFeed;
import org.mcsoxford.rss.RSSItem;
import org.mcsoxford.rss.RSSReader;

import java.sql.Array;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class HomeFragment extends Fragment {

    private FragmentHomeBinding binding;

    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        HomeViewModel homeViewModel =
                new ViewModelProvider(this).get(HomeViewModel.class);

        binding = FragmentHomeBinding.inflate(inflater, container, false);
        View root = binding.getRoot();

        //final TextView textView = binding.textHome;
        //homeViewModel.getText().observe(getViewLifecycleOwner(), textView::setText);

        ExecutorService executor = Executors.newCachedThreadPool();
        Future<String> future = executor.submit(() -> {
            Log.d("FEED", "LOAD FEED!");
            try(RSSReader reader = new RSSReader()) {
                RSSFeed feed = reader.load("https://sv-donaustauf.info/feed/");
                Log.d("FEED", feed.getTitle());

                for(RSSItem item : feed.getItems()) {
                    Log.d("FEED", item.getTitle() + "/" + item.getDescription() + "/" + item.getContent() + "/" + item.getLink());
                    break;
                }

                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
                    getActivity().runOnUiThread(() -> {
                        List<String> titles = new ArrayList<>();
                        for(RSSItem item : feed.getItems()) {
                            titles.add(item.getTitle());
                        }
                        binding.itemsList.setAdapter(new ArrayAdapter<>(requireContext(), android.R.layout.simple_list_item_1, titles));
                        binding.itemsList.setOnItemClickListener((parent, view, position, id) -> {
                            //textView.setText(Html.fromHtml(feed.getItems().get(position).getContent(), Html.FROM_HTML_MODE_COMPACT));
                            Bundle bundle = new Bundle();
                            bundle.putString("content", feed.getItems().get(position).getContent());
                            Navigation.findNavController(requireActivity(), R.id.nav_host_fragment_content_main).navigate(R.id.open_gallery_action, bundle);
                        });
                    });
                }

            }catch(Throwable e) {
                e.printStackTrace();
            }
            return null;
        });

        return root;
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
        binding = null;
    }
}